/* Problem URL: https://codeforces.com/edu/course/2/lesson/5/4/practice/contest/280801/problem/B */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    if (n > 1) {
        n = 1 << (32 - __builtin_clz(n - 1));
    }

    vl seg(n * 2);
    vl lazyconst(n * 2);
    vl lazyprog(n * 2);

    auto propagateconst = [&](int i) {
        if (lazyconst[i] == 0) {
            return;
        }

        if (i >= n) {
            seg[i] += lazyconst[i];
            lazyconst[i] = 0;
            return;
        }

        lazyconst[i * 2]  += lazyconst[i];
        lazyconst[i * 2 + 1] += lazyconst[i];
        lazyconst[i] = 0;
    };

    auto propagateprog = [&](int i) {
        if (lazyprog[i] == 0) {
            return;
        }

        if (i >= n) {
            seg[i] += lazyprog[i] * (i - n + 1);
            lazyprog[i] = 0;
            return;
        }

        lazyprog[i * 2] += lazyprog[i];
        lazyprog[i * 2 + 1] += lazyprog[i];
        lazyprog[i] = 0;
    };

    auto propagate = [&](int i) {
        propagateconst(i);
        propagateprog(i);
    };

    function<void(int, int, int, int, int, ll, ll)> update = [&](int i, int l, int r, int tl, int tr, ll c, ll p) {
        propagate(i);
        if (l > tr || r < tl) {
            return;
        }

        if (l >= tl && r <= tr) {
            lazyconst[i] += c;
            lazyprog[i] += p;
            propagate(i);
            return;
        }

        int mid = (l + r) >> 1;

        update(i * 2, l, mid, tl, tr, c, p);
        update(i * 2 + 1, mid + 1, r, tl, tr, c, p);
    };

    function<ll(int, int, int, int)> query = [&](int i, int l, int r, int t) {
        propagate(i);

        if (i >= n) {
            return seg[i];
        }

        int mid = (l + r) >> 1;

        if (mid >= t) {
            return query(i * 2, l, mid, t);
        }

        return query(i * 2 + 1, mid + 1, r, t);
    };

    while (m--) {
        int op;
        cin >> op;

        if (op == 1) {
            ll l, r, a, d;
            cin >> l >> r >> a >> d;
            update(1, 0, n - 1, l - 1, r - 1, a - d * l, d);
            continue;
        }

        int i;
        cin >> i;
        cout << query(1, 0, n - 1, i - 1) << '\n';
    }
}
